"use strict";
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.customtags = exports.htmltagsExtendsBluekeys = exports.jsVariables = exports.methodVariables = exports.greenVariables = exports.pinkKeywords = exports.blueKeywords = exports.nonBreakingCharacters = exports.lslash = exports.gt = exports.ls = exports.replacerIdentifiers = void 0;
const global_1 = require("./global");
let ids = 8765;
// let ids = 2;
exports.replacerIdentifiers = {
    string: (0, global_1.getCharacter)(ids++),
    comment: (0, global_1.getCharacter)(ids++),
    markdown: (0, global_1.getCharacter)(ids++),
    bluekeys: (0, global_1.getCharacter)(ids++),
    customkeys: (0, global_1.getCharacter)(ids++),
    greenkeys: (0, global_1.getCharacter)(ids++),
    pinkkeys: (0, global_1.getCharacter)(ids++),
    yellowkeys: (0, global_1.getCharacter)(ids++),
    varkeys: (0, global_1.getCharacter)(ids++),
    methodkeys: (0, global_1.getCharacter)(ids++),
    text: (0, global_1.getCharacter)(ids++),
    jsx: (0, global_1.getCharacter)(ids++),
    jsxJS: (0, global_1.getCharacter)(ids++),
    markdownJS: (0, global_1.getCharacter)(ids++),
    Chars: {
        ls: (0, global_1.getCharacter)(ids++),
        gt: (0, global_1.getCharacter)(ids++),
        lslash: (0, global_1.getCharacter)(ids++),
    },
    pathID: (0, global_1.getCharacter)(ids++)
};
_a = exports.replacerIdentifiers.Chars, exports.ls = _a.ls, exports.gt = _a.gt, exports.lslash = _a.lslash;
exports.nonBreakingCharacters = {
    all: [
        ';', ':', '{', '}', '(', ')', '[', ']', ',', '<', '>', '+', '-', '*', '/', '|', '&', '^', '%', '!', '~', '?', '=', '\\s', '.'
    ],
    start: [
        ';', ':', '{', '(', ',', '[', '<', '>', '+', '-', '*', '/', '|', '&', '%', '!', '~', '?', '=', '\\s'
    ],
    end: [
        ';', '}', '(', ',', ']', '<', '>', '+', '-', '*', '/', '|', '&', '%', '!', '~', '?', '=', '\\s', '.'
    ],
};
exports.blueKeywords = {
    // JavaScript keywords
    keys: [
        //'class',
        'const',
        'debugger',
        'delete',
        'enum',
        'extends',
        'function',
        'implements',
        'interface',
        'private',
        'public',
        'super',
        'yield',
        'let',
        'var',
        'void',
        'with',
        'typeof',
        'instanceof',
        'new',
        'this',
        'true',
        'false',
        'null',
        'undefined',
        'NaN',
        'Infinity',
        'arguments',
        'in',
        'of',
        'get',
        'set',
        'async',
    ],
    init(key, flag) {
        key = typeof key === 'string' ? [key] : this.keys;
        const keys = [...key, 'class'];
        const startingPattern = `(?<!\\S)\\b(${keys.join('|')})\\b|((?<=${exports.nonBreakingCharacters.start.map(global_1.excapeRegexChars).join('|')})\\b(${keys.join('|')})\\b)`;
        const pattern = `(${startingPattern})(?!=\\S)|(${startingPattern})(?=${exports.nonBreakingCharacters.end.map(global_1.excapeRegexChars).join('|')})`;
        return new RegExp(pattern, flag);
    },
    classname: 'blue-keyword'
};
exports.blueKeywords.pattern = exports.blueKeywords.init(undefined, 'gs');
exports.pinkKeywords = {
    // JavaScript keywords
    keys: [
        'await',
        'break',
        'case',
        'case:',
        'catch',
        'continue',
        'export',
        'as',
        'default',
        'from',
        'finally',
        'while',
        'do',
        'else',
        'if',
        'return',
        'switch',
        'throw',
        'try',
        'for',
        'import',
    ],
    init(key, flag) {
        key = typeof key === 'string' ? [key] : this.keys;
        const startingPattern = `(?<!\\S)\\b(${key.join('|')})\\b|((?<=${exports.nonBreakingCharacters.start.map(global_1.excapeRegexChars).join('|')})\\b(${key.join('|')})\\b)`;
        const pattern = `(${startingPattern})(?!=\\S)|(${startingPattern})(?=${exports.nonBreakingCharacters.end.map(global_1.excapeRegexChars).join('|')})`;
        return new RegExp(pattern, flag);
    },
    classname: 'pink-keyword'
};
exports.pinkKeywords.pattern = exports.pinkKeywords.init(undefined, 'gs');
exports.greenVariables = {
    // JavaScript pre-defined modules
    keys: [
        'Array',
        'Date',
        'RegExp',
        'Promise',
        'Set',
        'Map',
        'WeakSet',
        'WeakMap',
        'Function',
        'Boolean',
        'String',
        'Number',
        'Symbol',
        'Object',
        'Element',
        'Node',
        'Document',
        'Window',
        'Math',
        'JSON',
    ],
    init(key, flag) {
        key = typeof key === 'string' ? [key] : this.keys;
        const startingPattern = `(?<!\\S)\\b(${key.join('|')})\\b|((?<=${exports.nonBreakingCharacters.start.map(global_1.excapeRegexChars).join('|')})\\b(${key.join('|')})\\b)`;
        const pattern = `(${startingPattern})(?!=\\S)|(${startingPattern})(?=${exports.nonBreakingCharacters.end.map(global_1.excapeRegexChars).join('|')})`;
        return new RegExp(pattern, flag);
    },
    classname: 'green-keyword'
};
exports.greenVariables.pattern = exports.greenVariables.init(undefined, 'gs');
exports.methodVariables = {
    // JavaScript variables ^(?!y$)x$
    keys: '[a-zA-Z\\$_][0-9a-zA-Z\\$_]*',
    init(key, flag) {
        key = key || this.keys;
        const startingPattern = `(?<!\\S)(${key})|((?<=${exports.nonBreakingCharacters.start.map(global_1.excapeRegexChars).join('|')}|${(0, global_1.excapeRegexChars)('.')})${key})`;
        // const startingPattern = `(?<=\\s|[^\\S])(${key})`
        const pattern = `(${startingPattern})(?=\\s*\\()`;
        return new RegExp(pattern, flag);
    },
    classname: 'yellow-keyword'
};
exports.methodVariables.pattern = exports.methodVariables.init(undefined, 'gs');
exports.jsVariables = {
    // JavaScript variables
    keys: '[a-zA-Z\\$_][0-9a-zA-Z\\$_]*',
    init(key, flag) {
        key = key || this.keys;
        const startingPattern = `(?<!\\S)\\b(${key})\\b|((?<=${exports.nonBreakingCharacters.start.map(global_1.excapeRegexChars).join('|')}|${(0, global_1.excapeRegexChars)('.')})\\b(${key})\\b)`;
        const pattern = `(${startingPattern})(?!=\\S)|(${startingPattern})(?=${exports.nonBreakingCharacters.end.map(global_1.excapeRegexChars).join('|')})`;
        return RegExp(pattern, 'gs');
    },
    classname: 'cyan-keyword'
};
exports.jsVariables.pattern = exports.jsVariables.init(undefined, 'gs');
exports.htmltagsExtendsBluekeys = {
    // HTML tags
    keys: [
        'a', 'abbr', 'acronym', 'address', 'applet', 'area', 'article', 'aside', 'audio', 'b', 'base', 'basefont', 'bdi', 'bdo', 'big', 'blockquote', 'body', 'br', 'button', 'canvas', 'caption', 'center',
        'cite', 'code', 'col', 'colgroup', 'data', 'datalist', 'dd', 'del', 'details', 'dfn', 'dialog', 'dir', 'div', 'dl', 'dt', 'em', 'embed', 'fieldset', 'figcaption', 'figure', 'font', 'footer', 'form',
        'frame', 'frameset', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'head', 'header', 'hr', 'html', 'i', 'iframe', 'img', 'input', 'ins', 'kbd', 'label', 'legend', 'li', 'link', 'main', 'map', 'mark', 'meta', 'meter', 'nav', 'noframes',
        'noscript', 'object', 'ol', 'optgroup', 'option', 'output', 'p', 'param', 'picture', 'pre', 'progress', 'q', 'rp', 'rt', 'ruby', 's', 'samp', 'script', 'section', 'select', 'small', 'source',
        'span', 'strike', 'strong', 'style', 'sub', 'summary', 'sup', 'svg', 'table', 'tbody', 'td', 'template', 'textarea', 'tfoot', 'th', 'thead', 'time', 'title', 'tr', 'track', 'tt', 'u', 'ul',
        'var', 'video', 'wbr'
    ],
    init(key, flag) {
        key = typeof key === 'string' ? [key] : this.keys;
        const startingBluePattern = `(?<!\\S)\\b(${exports.blueKeywords.keys.join('|')})\\b|((?<=${exports.nonBreakingCharacters.start.map(global_1.excapeRegexChars).join('|')})\\b(${exports.blueKeywords.keys.join('|')})\\b)`;
        const bluePattern = `(${startingBluePattern})(?!=\\S)|(${startingBluePattern})(?=${exports.nonBreakingCharacters.end.map(global_1.excapeRegexChars).join('|')})`;
        const startingPattern = `((?<=${(0, global_1.excapeRegexChars)('<')}|${(0, global_1.excapeRegexChars)('</')}[ ]*)\\b(${key.join('|')})\\b)`;
        const pattern = `(${startingPattern})(?=\\>|\\/\\>|.*?\\/\\>|.*?\\>)|${bluePattern}`;
        return new RegExp(pattern, flag);
    },
    classname: 'html-tag'
};
exports.htmltagsExtendsBluekeys.pattern = exports.htmltagsExtendsBluekeys.init(undefined, 'gs');
exports.customtags = {
    // Custom tags
    keys: '[A-Z\\$][0-9a-zA-Z\\$_]*',
    init(key, flag) {
        key = key || this.keys;
        const startingPattern = `((?<=${(0, global_1.excapeRegexChars)('<')}|${(0, global_1.excapeRegexChars)('</')}[ ]*)\\b(${key})\\b)`;
        const pattern = `(${startingPattern})(?=\\s*${(0, global_1.excapeRegexChars)('>')}|\\s*${(0, global_1.excapeRegexChars)('/>')}|\\s+(.*?)\\s*${(0, global_1.excapeRegexChars)('>')}|\\s+(.*?)\\s*${(0, global_1.excapeRegexChars)('/>')})`;
        return new RegExp(`${pattern}`, 'gs');
    },
    classname: 'html-tag'
};
exports.customtags.pattern = exports.customtags.init(undefined, 'gs');
