"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReplaceToken = exports.RemoveToken = exports.write = exports.getReplacer = void 0;
const constants_1 = require("./constants");
const patterns_1 = require("./patterns");
const rand = `${Math.random()}`.replace('.', '');
function getReplacer(name) {
    return `${constants_1.replacerIdentifiers[name]}${rand}_`;
}
exports.getReplacer = getReplacer;
function write(code) {
    let writes = code.match(patterns_1.writePattern);
    if (!writes)
        return code;
    let word, length;
    for (let i = 0; i < writes.length; i++) {
        word = writes[i];
        length = word.length;
        word = word.replace(/\/\/[ ]+\\write[ ]+/, '');
        if (/(\s+\\n\s*\n\s*\S)$/.test(word)) {
            code = code.replace(writes[i], word.split('\\n').join(''));
        }
        else {
            word = word.replace(/(\s*\n\s*\S)$/, '');
            code = code.replace(writes[i], `${word} ${writes[i][length - 1]}`);
        }
    }
    return write(code);
}
exports.write = write;
function RemoveToken(name, code, pattern) {
    let matches = code.match(pattern);
    // console.log(name);
    // console.log(matches);
    const replacer = getReplacer(name);
    let i;
    if (matches) {
        switch (name) {
            case 'bluekeys':
                code = code.replace(pattern, replacer);
                break;
            case 'yellowkeys':
                for (i = 0; i < matches.length; i++) {
                    code = code.replace(constants_1.methodVariables.init(matches[i]), `${replacer}${i}${replacer}`);
                }
                break;
            case 'customkeys':
                for (i = 0; i < matches.length; i++) {
                    code = code.replace(constants_1.customtags.init(matches[i]), `${replacer}${i}${replacer}`);
                }
                break;
            default:
                for (let i = 0; i < matches.length; i++) {
                    code = code.replace(matches[i], `${replacer}${i}${replacer}`);
                    // code = replace(code, matches[i], `${replacer}${i}${replacer}`)
                }
                break;
        }
        if (name == 'text') {
            matches = matches.join(replacer).replace(/<x-text>/gs, '').replace(/<\/x-text>/gs, '').split(replacer);
        }
    }
    else {
        matches = [];
    }
    // console.log(code);
    const data = { code: code, [name]: matches };
    return data;
}
exports.RemoveToken = RemoveToken;
const replace = (original_str, search_str, replacer) => {
    const index = original_str.indexOf(search_str);
    if (search_str === 'configureForReact') {
        console.log(index, original_str.length, replacer);
    }
    if (index >= 0) {
        const before = original_str.slice(0, index) || '';
        const after = original_str.slice(index + search_str.length) || '';
        if (search_str === 'configureForReact') {
            console.log(index, (before + after).length, original_str.split(search_str).length);
            // return original_str
        }
        return before + replacer + after;
    }
    return original_str;
};
function ReplaceToken(name, classname, code, tokens) {
    const replacer = getReplacer(name);
    if (name === 'bluekeys') {
        for (var i = 0; i < tokens.length; i++) {
            code = code.replace(replacer, `${constants_1.ls}span class="xmk-${classname}"${constants_1.gt}${tokens[i]}${constants_1.lslash}span${constants_1.gt}`);
        }
    }
    else {
        switch (name) {
            case 'yellowkeys':
            case 'customkeys':
                for (let i = 0; i < tokens.length; i++) {
                    code = code.replace(RegExp(`${replacer}${i}${replacer}`, 'gs'), `${constants_1.ls}span class="xmk-${classname}"${constants_1.gt}${tokens[i]}${constants_1.lslash}span${constants_1.gt}`);
                }
                break;
            default:
                for (let i = 0; i < tokens.length; i++) {
                    code = code.replace(`${replacer}${i}${replacer}`, `${constants_1.ls}span class="xmk-${classname}"${constants_1.gt}${tokens[i]}${constants_1.lslash}span${constants_1.gt}`);
                }
                break;
        }
    }
    return code;
}
exports.ReplaceToken = ReplaceToken;
