"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseCodeString = exports.parseMarkdown = void 0;
const fs_1 = require("fs");
const path_1 = require("path");
const helper_1 = require("../helper");
const patterns_1 = require("../patterns");
const constants_1 = require("../constants");
const jsx_1 = require("./jsx");
const js_1 = require("./js");
function parseMarkdown(maincode, relativeDirectory, returnAsString) {
    let data = (0, helper_1.RemoveToken)('markdownJS', maincode, patterns_1.xmarkdownPattern);
    maincode = data.code;
    const markdownJS = data.markdownJS;
    let markdown = [];
    let replacer = (0, helper_1.getReplacer)('string');
    let markdownCode;
    for (let i = 0; i < markdownJS.length; i++) {
        markdownCode = markdownJS[i].replace(/\n\t|\n  /gs, '\n');
        data = (0, helper_1.RemoveToken)('jsx', markdownCode, patterns_1.xjsxPattern);
        markdown.push({
            jsx: data.jsx,
            code: data.code,
            JS: [],
            jsxCode: ''
        });
    }
    let levelJS, j, lenth, parsedJS;
    let levelJSX, levelCode;
    let pathCode = '', srcPath = '';
    for (let i = 0; i < markdown.length; i++) {
        levelJSX = markdown[i].jsx;
        srcPath = pathCode = '';
        let startPattern = /\s*\/\/<x-jsx>\s*\n/;
        let endPattern = /\s*\/\/<\/x-jsx>\s*\n/;
        replacer = (0, helper_1.getReplacer)('jsxJS');
        for (j = 0; j < levelJSX.length; j++) {
            levelJSX[j] = levelJSX[j].replace(startPattern, '').replace(endPattern, '');
            levelJSX[j] = (0, jsx_1.parseJSX)(levelJSX[j]);
            data = (0, helper_1.RemoveToken)('jsxJS', levelJSX[j], patterns_1.xjsxJSPattern);
            lenth = data.jsxJS.length;
            for (let k = 0; k < lenth; k++) {
                parsedJS = (0, js_1.parseJSOnly)(data.jsxJS[k]);
                levelJSX[j] = levelJSX[j].replace(`${replacer}${k}${replacer}`, `${constants_1.ls}div class="xmk-js2x"${constants_1.gt}${parsedJS}${constants_1.lslash}div${constants_1.gt}`);
            }
        }
        startPattern = /\/\/<xyntax\s+path\s*=\s*('\S+'|"\S+")\s+[a-zA-Z-0-9\$_]+>\s*{/;
        endPattern = /}\s*\/\/<\/xyntax>/;
        levelCode = markdown[i].code;
        let markdownId = levelCode.match(/\/\/<xyntax\s+path\s*=\s*('\S+'|"\S+")\s+[a-zA-Z-0-9\$_]+>/gs)[0];
        markdownId = markdownId.replace(/\/\/<xyntax\s+path\s*=\s*('|")/, '').replace(/>$/, '').split(/\s+/);
        let writeToFilePath = markdownId[0].replace(/('|")$/, '');
        markdownId = markdownId[1];
        levelCode = levelCode.replace(startPattern, ' ').replace(endPattern, ' ');
        levelCode = (0, js_1.parseJSOnly)(levelCode);
        replacer = (0, helper_1.getReplacer)('jsx');
        lenth = levelJSX.length;
        for (let k = 0; k < lenth; k++) {
            levelCode = levelCode.replace(`${replacer}${k}${replacer}`, `${constants_1.ls}div class="xmk-jsx"${constants_1.gt}${levelJSX[k]}${constants_1.lslash}div${constants_1.gt}`);
        }
        levelCode = `${constants_1.ls}div class="xmk-js1x"${constants_1.gt}${levelCode}${constants_1.lslash}div${constants_1.gt}`;
        levelCode = levelCode.replace(/&/gs, '&#38').replace(/</gs, '&#60;').replace(/>/gs, '&#62;')
            .replace(/\//gs, '&#47;').replace(/\{/gs, '&#123;').replace(/\}/gs, '&#125;').replace(/`/gs, '&#96;')
            .replace(RegExp(`${constants_1.ls}`, 'gs'), '<').replace(RegExp(`${constants_1.lslash}`, 'gs'), '</').replace(RegExp(`${constants_1.gt}`, 'gs'), '>');
        if (returnAsString) {
            return levelCode;
        }
        markdown[i] = '';
        replacer = (0, helper_1.getReplacer)('markdownJS');
        maincode = maincode.replace(`${replacer}${i}${replacer}`, '\n');
        srcPath = (0, path_1.resolve)(relativeDirectory, writeToFilePath);
        pathCode = (0, fs_1.readFileSync)(srcPath, 'utf8');
        replacer = (0, helper_1.getReplacer)('pathID');
        let allToReplace = pathCode.match(RegExp("(?<!\\\\)`[^`]*?(?<!\\\\)`\\s*;*\\s*\\/\\/[ ]*\\\\insert[ ]+" + markdownId + "\\s", 'gs'));
        if (!allToReplace) {
            continue;
        }
        pathCode = pathCode.replace(RegExp("(?<!\\\\)`[^`]*?(?<!\\\\)`\\s*;*\\s*\\/\\/[ ]*\\\\insert[ ]+" + markdownId + "\\s", 'gs'), replacer);
        for (let i = 0; i < allToReplace.length; i++) {
            pathCode = pathCode.replace(replacer, `\`${levelCode}\`; // \\insert ${markdownId} `);
        }
        (0, fs_1.writeFileSync)(srcPath, pathCode);
    }
}
exports.parseMarkdown = parseMarkdown;
function parseCodeString(code) {
    return parseMarkdown(`//<xyntax path="./src/pre-highlighted-codes.js" my_button>{${code}}//</xyntax>`, '', true);
}
exports.parseCodeString = parseCodeString;
