"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseJSX = void 0;
const constants_1 = require("../constants");
const helper_1 = require("../helper");
const patterns_1 = require("../patterns");
function parseJSX(maincode) {
    let data = (0, helper_1.RemoveToken)('string', maincode, patterns_1.stringsPattern);
    const strings = data.string;
    data = (0, helper_1.RemoveToken)('comment', (0, helper_1.write)(data.code), patterns_1.commentsPattern);
    const comments = data.comment;
    data = (0, helper_1.RemoveToken)('text', data.code, patterns_1.xtextPattern);
    const texts = data.text;
    data = (0, helper_1.RemoveToken)('customkeys', data.code, constants_1.customtags.pattern);
    const customtagkeys = data.customkeys;
    data = (0, helper_1.RemoveToken)('bluekeys', data.code, constants_1.htmltagsExtendsBluekeys.pattern);
    const bluekeys = data.bluekeys;
    data = (0, helper_1.RemoveToken)('pinkkeys', data.code, constants_1.pinkKeywords.pattern);
    const pinkkeys = data.pinkkeys;
    data = (0, helper_1.RemoveToken)('greenkeys', data.code, constants_1.greenVariables.pattern);
    const greenkeys = data.greenkeys;
    data = (0, helper_1.RemoveToken)('yellowkeys', data.code, constants_1.methodVariables.pattern);
    const yellowkeys = data.yellowkeys;
    data = (0, helper_1.RemoveToken)('varkeys', data.code, constants_1.jsVariables.pattern);
    const varkeys = data.varkeys;
    let code = data.code;
    data = null;
    code =
        (0, helper_1.ReplaceToken)('string', 'stringx', (0, helper_1.ReplaceToken)('comment', 'commentx', (0, helper_1.ReplaceToken)('text', 'text', (0, helper_1.ReplaceToken)('customkeys', 'predefx', (0, helper_1.ReplaceToken)('bluekeys', 'key1x', (0, helper_1.ReplaceToken)('pinkkeys', 'key2x', (0, helper_1.ReplaceToken)('greenkeys', 'predefx', (0, helper_1.ReplaceToken)('yellowkeys', 'methx', (0, helper_1.ReplaceToken)('varkeys', 'varx', code, varkeys), yellowkeys), greenkeys), pinkkeys), bluekeys), customtagkeys), texts), comments), strings);
    return code;
}
exports.parseJSX = parseJSX;
